Index: pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/conf_switch.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/conf_switch.c	(revision 3391)
+++ pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/conf_switch.c	(revision 3392)
@@ -24,8 +24,8 @@
 #include <pjmedia/silencedet.h>
 #include <pjmedia/sound_port.h>
-#include <pjmedia/stream.h>
 #include <pj/array.h>
 #include <pj/assert.h>
 #include <pj/log.h>
+#include <pj/math.h>
 #include <pj/pool.h>
 #include <pj/string.h>
@@ -81,4 +81,5 @@
     /* Shortcut for port info. */
     pjmedia_port_info	*info;
+    unsigned		 samples_per_frame;
 
     /* Calculated signal levels: */
@@ -124,5 +125,5 @@
 /* Prototypes */
 static pj_status_t put_frame(pjmedia_port *this_port, 
-			     const pjmedia_frame *frame);
+			     pjmedia_frame *frame);
 static pj_status_t get_frame(pjmedia_port *this_port, 
 			     pjmedia_frame *frame);
@@ -167,4 +168,5 @@
     conf_port->port = port;
     conf_port->info = &port->info;
+    conf_port->samples_per_frame= PJMEDIA_PINFO_SAMPLES_PER_FRAME(&port->info);
 
     /* Init pjmedia_frame structure in the TX buffer. */
@@ -505,4 +507,5 @@
     struct conf_port *src_port, *dst_port;
     pj_bool_t start_sound = PJ_FALSE;
+    pjmedia_audio_format_detail *src_afd, *dst_afd;
     unsigned i;
 
@@ -524,7 +527,10 @@
     }
 
+    src_afd = pjmedia_format_get_audio_format_detail(&src_port->info->fmt, 1);
+    dst_afd = pjmedia_format_get_audio_format_detail(&dst_port->info->fmt, 1);
+
     /* Format must match. */
-    if (src_port->info->format.id != dst_port->info->format.id ||
-	src_port->info->format.bitrate != dst_port->info->format.bitrate) 
+    if (src_port->info->fmt.id != dst_port->info->fmt.id ||
+	src_afd->avg_bps != dst_afd->avg_bps)
     {
 	pj_mutex_unlock(conf->mutex);
@@ -533,5 +539,5 @@
 
     /* Clock rate must match. */
-    if (src_port->info->clock_rate != dst_port->info->clock_rate) {
+    if (src_afd->clock_rate != dst_afd->clock_rate) {
 	pj_mutex_unlock(conf->mutex);
 	return PJMEDIA_ENCCLOCKRATE;
@@ -539,5 +545,5 @@
 
     /* Channel count must match. */
-    if (src_port->info->channel_count != dst_port->info->channel_count) {
+    if (src_afd->channel_count != dst_afd->channel_count) {
 	pj_mutex_unlock(conf->mutex);
 	return PJMEDIA_ENCCLOCKRATE;
@@ -545,8 +551,6 @@
 
     /* Source and sink ptime must be equal or a multiplication factor. */
-    if ((src_port->info->samples_per_frame % 
-	 dst_port->info->samples_per_frame != 0) &&
-        (dst_port->info->samples_per_frame % 
-         src_port->info->samples_per_frame != 0))
+    if ((src_afd->frame_time_usec % dst_afd->frame_time_usec != 0) &&
+        (dst_afd->frame_time_usec % src_afd->frame_time_usec != 0))
     {
 	pj_mutex_unlock(conf->mutex);
@@ -830,4 +834,5 @@
 {
     struct conf_port *conf_port;
+    const pjmedia_audio_format_detail *afd;
 
     /* Check arguments */
@@ -843,4 +848,6 @@
 	return PJ_EINVAL;
     }
+
+    afd = pjmedia_format_get_audio_format_detail(&conf_port->info->fmt, 1);
 
     pj_bzero(info, sizeof(pjmedia_conf_port_info));
@@ -853,9 +860,9 @@
     info->listener_slots = conf_port->listener_slots;
     info->transmitter_cnt = conf_port->transmitter_cnt;
-    info->clock_rate = conf_port->info->clock_rate;
-    info->channel_count = conf_port->info->channel_count;
-    info->samples_per_frame = conf_port->info->samples_per_frame;
-    info->bits_per_sample = conf_port->info->bits_per_sample;
-    info->format = conf_port->port->info.format;
+    info->clock_rate = afd->clock_rate;
+    info->channel_count = afd->channel_count;
+    info->samples_per_frame = conf_port->samples_per_frame;
+    info->bits_per_sample = afd->bits_per_sample;
+    info->format = conf_port->port->info.fmt;
     info->tx_adj_level = conf_port->tx_adj_level - NORMAL_LEVEL;
     info->rx_adj_level = conf_port->rx_adj_level - NORMAL_LEVEL;
@@ -961,5 +968,5 @@
 
     /* Level adjustment is applicable only for ports that work with raw PCM. */
-    PJ_ASSERT_RETURN(conf_port->info->format.id == PJMEDIA_FORMAT_L16,
+    PJ_ASSERT_RETURN(conf_port->info->fmt.id == PJMEDIA_FORMAT_L16,
 		     PJ_EIGNORED);
 
@@ -1003,5 +1010,5 @@
 
     /* Level adjustment is applicable only for ports that work with raw PCM. */
-    PJ_ASSERT_RETURN(conf_port->info->format.id == PJMEDIA_FORMAT_L16,
+    PJ_ASSERT_RETURN(conf_port->info->fmt.id == PJMEDIA_FORMAT_L16,
 		     PJ_EIGNORED);
 
@@ -1047,5 +1054,5 @@
 	     * samples per frame.
 	     */
-	    if (f_dst->samples_cnt >= cport_dst->info->samples_per_frame)
+	    if (f_dst->samples_cnt >= cport_dst->samples_per_frame)
 	    {
 		if (cport_dst->slot) {
@@ -1059,6 +1066,6 @@
 
 		/* Update TX timestamp. */
-		pj_add_timestamp32(&cport_dst->ts_tx, 
-				   cport_dst->info->samples_per_frame);
+		pj_add_timestamp32(&cport_dst->ts_tx,
+				   cport_dst->samples_per_frame);
 	    }
 	}
@@ -1076,5 +1083,5 @@
 	    /* Copy frame to listener's TX buffer. */
 	    nsamples_to_copy = f_end - f_start;
-	    nsamples_req = cport_dst->info->samples_per_frame - 
+	    nsamples_req = cport_dst->samples_per_frame -
 			  (frm_dst->size>>1);
 	    if (nsamples_to_copy > nsamples_req)
@@ -1113,5 +1120,5 @@
 	     * samples per frame.
 	     */
-	    if ((frm_dst->size >> 1) == cport_dst->info->samples_per_frame)
+	    if ((frm_dst->size >> 1) == cport_dst->samples_per_frame)
 	    {
 		if (cport_dst->slot) {
@@ -1124,5 +1131,5 @@
 		/* Update TX timestamp. */
 		pj_add_timestamp32(&cport_dst->ts_tx, 
-				   cport_dst->info->samples_per_frame);
+				   cport_dst->samples_per_frame);
 	    }
 	}
@@ -1132,5 +1139,5 @@
 	/* Check port format. */
 	if (cport_dst->port &&
-	    cport_dst->port->info.format.id == PJMEDIA_FORMAT_L16)
+	    cport_dst->port->info.fmt.id == PJMEDIA_FORMAT_L16)
 	{
 	    /* When there is already some samples in listener's TX buffer, 
@@ -1139,9 +1146,9 @@
 	    if (frm_dst->size != 0) {
 		pjmedia_zero_samples((pj_int16_t*)frm_dst->buf,
-				     cport_dst->info->samples_per_frame - 
+				     cport_dst->samples_per_frame -
 				     (frm_dst->size>>1));
 
 		frm_dst->type = PJMEDIA_FRAME_TYPE_AUDIO;
-		frm_dst->size = cport_dst->info->samples_per_frame << 1;
+		frm_dst->size = cport_dst->samples_per_frame << 1;
 		if (cport_dst->slot) {
 		    pjmedia_port_put_frame(cport_dst->port, frm_dst);
@@ -1153,5 +1160,5 @@
 		/* Update TX timestamp. */
 		pj_add_timestamp32(&cport_dst->ts_tx, 
-				   cport_dst->info->samples_per_frame);
+				   cport_dst->samples_per_frame);
 	    }
 	} else {
@@ -1161,5 +1168,5 @@
 		frm_dst->type = PJMEDIA_FRAME_TYPE_EXTENDED;
 		pjmedia_frame_ext_append_subframe(f_dst, NULL, 0, (pj_uint16_t)
-		    (cport_dst->info->samples_per_frame - f_dst->samples_cnt));
+		    (cport_dst->samples_per_frame - f_dst->samples_cnt));
 		if (cport_dst->slot) {
 		    pjmedia_port_put_frame(cport_dst->port, frm_dst);
@@ -1172,5 +1179,5 @@
 		/* Update TX timestamp. */
 		pj_add_timestamp32(&cport_dst->ts_tx, 
-				   cport_dst->info->samples_per_frame);
+				   cport_dst->samples_per_frame);
 	    }
 	}
@@ -1186,5 +1193,5 @@
 
 	    /* Update TX timestamp. */
-	    pj_add_timestamp32(&cport_dst->ts_tx, cport_dst->info->samples_per_frame);
+	    pj_add_timestamp32(&cport_dst->ts_tx, cport_dst->samples_per_frame);
 	}
     }
@@ -1212,4 +1219,5 @@
     for (i=1, ci=1; i<conf->max_ports && ci<conf->port_cnt; ++i) {
 	struct conf_port *cport = conf->ports[i];
+	unsigned master_samples_per_frame;
 
 	/* Skip empty port. */
@@ -1220,7 +1228,9 @@
 	++ci;
 
+	master_samples_per_frame = PJMEDIA_PINFO_SAMPLES_PER_FRAME(
+					&conf->master_port->info);
+
 	/* Update clock of the port. */
-	pj_add_timestamp32(&cport->ts_clock, 
-			   conf->master_port->info.samples_per_frame);
+	pj_add_timestamp32(&cport->ts_clock, master_samples_per_frame);
 
 	/* Skip if we're not allowed to receive from this port or 
@@ -1231,6 +1241,5 @@
 	{
 	    cport->rx_level = 0;
-	    pj_add_timestamp32(&cport->ts_rx, 
-			       conf->master_port->info.samples_per_frame);
+	    pj_add_timestamp32(&cport->ts_rx, master_samples_per_frame);
 	    continue;
 	}
@@ -1246,8 +1255,8 @@
 	    pj_int32_t level = 0;
 
-	    pj_add_timestamp32(&cport->ts_rx, cport->info->samples_per_frame);
+	    pj_add_timestamp32(&cport->ts_rx, cport->samples_per_frame);
 	    
 	    f->buf = &conf->buf[sizeof(pjmedia_frame)];
-	    f->size = cport->info->samples_per_frame<<1;
+	    f->size = cport->samples_per_frame<<1;
 
 	    /* Get frame from port. */
@@ -1303,5 +1312,5 @@
 		if (listener->tx_setting == PJMEDIA_PORT_DISABLE) {
 		    pj_add_timestamp32(&listener->ts_tx, 
-				       listener->info->samples_per_frame);
+				       listener->samples_per_frame);
 		    listener->tx_level = 0;
 		    continue;
@@ -1362,5 +1371,5 @@
 
 		    pjmedia_port_put_frame(cport->port, &tmp_f);
-		    pj_add_timestamp32(&cport->ts_tx, cport->info->samples_per_frame);
+		    pj_add_timestamp32(&cport->ts_tx, cport->samples_per_frame);
 		}
 	    }
@@ -1381,5 +1390,5 @@
 	    unsigned samples_per_subframe;
 	    
-	    if (f_src_->samples_cnt < this_cport->info->samples_per_frame) {
+	    if (f_src_->samples_cnt < this_cport->samples_per_frame) {
 		f_dst->base.type = PJMEDIA_FRAME_TYPE_NONE;
 		f_dst->samples_cnt = 0;
@@ -1394,5 +1403,5 @@
 
 
-	    while (f_dst->samples_cnt < this_cport->info->samples_per_frame) {
+	    while (f_dst->samples_cnt < this_cport->samples_per_frame) {
 		sf = pjmedia_frame_ext_get_subframe(f_src_, i++);
 		pj_assert(sf);
@@ -1405,5 +1414,5 @@
 
 	} else if (f_src->type == PJMEDIA_FRAME_TYPE_AUDIO) {
-	    if ((f_src->size>>1) < this_cport->info->samples_per_frame) {
+	    if ((f_src->size>>1) < this_cport->samples_per_frame) {
 		frame->type = PJMEDIA_FRAME_TYPE_NONE;
 		frame->size = 0;
@@ -1413,6 +1422,6 @@
 	    pjmedia_copy_samples((pj_int16_t*)frame->buf, 
 				 (pj_int16_t*)f_src->buf, 
-				 this_cport->info->samples_per_frame);
-	    frame->size = this_cport->info->samples_per_frame << 1;
+				 this_cport->samples_per_frame);
+	    frame->size = this_cport->samples_per_frame << 1;
 
 	    /* Shift left TX buffer. */
@@ -1421,5 +1430,5 @@
 		pjmedia_move_samples((pj_int16_t*)f_src->buf,
 				     (pj_int16_t*)f_src->buf + 
-				     this_cport->info->samples_per_frame,
+				     this_cport->samples_per_frame,
 				     f_src->size >> 1);
 	} else { /* PJMEDIA_FRAME_TYPE_NONE */
@@ -1443,5 +1452,5 @@
  */
 static pj_status_t put_frame(pjmedia_port *this_port, 
-			     const pjmedia_frame *f)
+			     pjmedia_frame *f)
 {
     pjmedia_conf *conf = (pjmedia_conf*) this_port->port_data.pdata;
@@ -1461,5 +1470,5 @@
     }
 
-    pj_add_timestamp32(&cport->ts_rx, cport->info->samples_per_frame);
+    pj_add_timestamp32(&cport->ts_rx, cport->samples_per_frame);
     
     /* Skip if this port is muted/disabled. */
@@ -1527,5 +1536,5 @@
 	if (listener->tx_setting == PJMEDIA_PORT_DISABLE) {
 	    pj_add_timestamp32(&listener->ts_tx, 
-			       listener->info->samples_per_frame);
+			       listener->samples_per_frame);
 	    listener->tx_level = 0;
 	    continue;
@@ -1535,5 +1544,5 @@
 	if (listener == cport) {
 	    pj_add_timestamp32(&listener->ts_tx, 
-			       listener->info->samples_per_frame);
+			       listener->samples_per_frame);
 	    listener->tx_level = 0;
 	    continue;
Index: pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/conference.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/conference.c	(revision 3391)
+++ pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/conference.c	(revision 3392)
@@ -27,5 +27,4 @@
 #include <pjmedia/sound_port.h>
 #include <pjmedia/stereo.h>
-#include <pjmedia/stream.h>
 #include <pj/array.h>
 #include <pj/assert.h>
@@ -242,5 +241,5 @@
 /* Prototypes */
 static pj_status_t put_frame(pjmedia_port *this_port, 
-			     const pjmedia_frame *frame);
+			     pjmedia_frame *frame);
 static pj_status_t get_frame(pjmedia_port *this_port, 
 			     pjmedia_frame *frame);
@@ -286,8 +285,11 @@
     /* Save some port's infos, for convenience. */
     if (port) {
+	pjmedia_audio_format_detail *afd;
+
+	afd = pjmedia_format_get_audio_format_detail(&port->info.fmt, 1);
 	conf_port->port = port;
-	conf_port->clock_rate = port->info.clock_rate;
-	conf_port->samples_per_frame = port->info.samples_per_frame;
-	conf_port->channel_count = port->info.channel_count;
+	conf_port->clock_rate = afd->clock_rate;
+	conf_port->samples_per_frame = PJMEDIA_AFD_SPF(afd);
+	conf_port->channel_count = afd->channel_count;
     } else {
 	conf_port->port = NULL;
@@ -751,6 +753,7 @@
      * - monochannel on port or conference bridge.
      */
-    if (strm_port->info.channel_count != conf->channel_count && 
-	(strm_port->info.channel_count != 1 && conf->channel_count != 1)) 
+    if (PJMEDIA_PIA_CCNT(&strm_port->info) != conf->channel_count &&
+	(PJMEDIA_PIA_CCNT(&strm_port->info) != 1 &&
+	 conf->channel_count != 1))
     {
 	pj_assert(!"Number of channels mismatch");
@@ -2051,5 +2054,5 @@
  */
 static pj_status_t put_frame(pjmedia_port *this_port, 
-			     const pjmedia_frame *frame)
+			     pjmedia_frame *frame)
 {
     pjmedia_conf *conf = (pjmedia_conf*) this_port->port_data.pdata;
Index: pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/converter.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/converter.c	(revision 3392)
+++ pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/converter.c	(revision 3392)
@@ -0,0 +1,162 @@
+/* $Id$ */
+/*
+ * Copyright (C) 2010-2011 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+#include <pjmedia/converter.h>
+#include <pj/assert.h>
+#include <pj/errno.h>
+
+
+struct pjmedia_converter_mgr
+{
+    pjmedia_converter_factory  factory_list;
+};
+
+static pjmedia_converter_mgr *converter_manager_instance;
+
+PJ_DEF(pj_status_t) pjmedia_converter_mgr_create(pj_pool_t *pool,
+					         pjmedia_converter_mgr **p_mgr)
+{
+    pjmedia_converter_mgr *mgr;
+
+    mgr = PJ_POOL_ALLOC_T(pool, pjmedia_converter_mgr);
+    pj_list_init(&mgr->factory_list);
+
+    if (!converter_manager_instance)
+	converter_manager_instance = mgr;
+
+    if (p_mgr)
+	*p_mgr = mgr;
+
+    return PJ_SUCCESS;
+}
+
+PJ_DEF(pjmedia_converter_mgr*) pjmedia_converter_mgr_instance(void)
+{
+    pj_assert(converter_manager_instance != NULL);
+    return converter_manager_instance;
+}
+
+PJ_DEF(void) pjmedia_converter_mgr_set_instance(pjmedia_converter_mgr *mgr)
+{
+    converter_manager_instance = mgr;
+}
+
+PJ_DEF(void) pjmedia_converter_mgr_destroy(pjmedia_converter_mgr *mgr)
+{
+    pjmedia_converter_factory *f;
+
+    if (!mgr) mgr = pjmedia_converter_mgr_instance();
+
+    PJ_ASSERT_ON_FAIL(mgr != NULL, return);
+
+    f = mgr->factory_list.next;
+    while (f != &mgr->factory_list) {
+	pjmedia_converter_factory *next = f->next;
+	pj_list_erase(f);
+	(*f->op->destroy_factory)(f);
+	f = next;
+    }
+
+    if (converter_manager_instance == mgr)
+	converter_manager_instance = NULL;
+}
+
+PJ_DEF(pj_status_t)
+pjmedia_converter_mgr_register_factory(pjmedia_converter_mgr *mgr,
+				       pjmedia_converter_factory *factory)
+{
+    pjmedia_converter_factory *pf;
+
+    if (!mgr) mgr = pjmedia_converter_mgr_instance();
+
+    PJ_ASSERT_RETURN(mgr != NULL, PJ_EINVAL);
+
+    PJ_ASSERT_RETURN(!pj_list_find_node(&mgr->factory_list, factory),
+		     PJ_EEXISTS);
+
+    pf = mgr->factory_list.next;
+    while (pf != &mgr->factory_list) {
+	if (pf->priority > factory->priority)
+	    break;
+	pf = pf->next;
+    }
+    pj_list_insert_before(pf, factory);
+    return PJ_SUCCESS;
+}
+
+
+PJ_DEF(pj_status_t)
+pjmedia_converter_mgr_unregister_factory(pjmedia_converter_mgr *mgr,
+				         pjmedia_converter_factory *f,
+				         pj_bool_t destroy)
+{
+    if (!mgr) mgr = pjmedia_converter_mgr_instance();
+
+    PJ_ASSERT_RETURN(mgr != NULL, PJ_EINVAL);
+
+    PJ_ASSERT_RETURN(pj_list_find_node(&mgr->factory_list, f), PJ_ENOTFOUND);
+    pj_list_erase(f);
+    if (destroy)
+	(*f->op->destroy_factory)(f);
+    return PJ_SUCCESS;
+}
+
+PJ_DEF(pj_status_t) pjmedia_converter_create(pjmedia_converter_mgr *mgr,
+					      pj_pool_t *pool,
+					      pjmedia_conversion_param *param,
+					      pjmedia_converter **p_cv)
+{
+    pjmedia_converter_factory *f;
+    pjmedia_converter *cv = NULL;
+    pj_status_t status = PJ_ENOTFOUND;
+
+    if (!mgr) mgr = pjmedia_converter_mgr_instance();
+
+    PJ_ASSERT_RETURN(mgr != NULL, PJ_EINVAL);
+
+    *p_cv = NULL;
+
+    f = mgr->factory_list.next;
+    while (f != &mgr->factory_list) {
+	status = (*f->op->create_converter)(f, pool, param, &cv);
+	if (status == PJ_SUCCESS)
+	    break;
+	f = f->next;
+    }
+
+    if (status != PJ_SUCCESS)
+	return status;
+
+    *p_cv = cv;
+
+    return PJ_SUCCESS;
+}
+
+PJ_DEF(pj_status_t) pjmedia_converter_convert(pjmedia_converter *cv,
+					       pjmedia_frame *src_frame,
+					       pjmedia_frame *dst_frame)
+{
+    return (*cv->op->convert)(cv, src_frame, dst_frame);
+}
+
+PJ_DEF(void) pjmedia_converter_destroy(pjmedia_converter *cv)
+{
+    (*cv->op->destroy)(cv);
+}
+
+
Index: pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/converter_libswscale.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/converter_libswscale.c	(revision 3392)
+++ pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/converter_libswscale.c	(revision 3392)
@@ -0,0 +1,202 @@
+/* $Id$ */
+/*
+ * Copyright (C) 2010-2011 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+#include <pjmedia/converter.h>
+#include <pj/errno.h>
+
+#if PJMEDIA_HAS_LIBSWSCALE && PJMEDIA_HAS_LIBAVUTIL
+
+#include "ffmpeg_util.h"
+#include <libswscale/swscale.h>
+
+static pj_status_t factory_create_converter(pjmedia_converter_factory *cf,
+					    pj_pool_t *pool,
+					    const pjmedia_conversion_param*prm,
+					    pjmedia_converter **p_cv);
+static void factory_destroy_factory(pjmedia_converter_factory *cf);
+static pj_status_t libswscale_conv_convert(pjmedia_converter *converter,
+					   pjmedia_frame *src_frame,
+					   pjmedia_frame *dst_frame);
+static void libswscale_conv_destroy(pjmedia_converter *converter);
+
+
+struct fmt_info
+{
+    const pjmedia_video_format_info 	*fmt_info;
+    pjmedia_video_apply_fmt_param 	 apply_param;
+};
+
+struct ffmpeg_converter
+{
+    pjmedia_converter 			 base;
+    struct SwsContext 			*sws_ctx;
+    struct fmt_info			 src,
+					 dst;
+};
+
+static pjmedia_converter_factory_op libswscale_factory_op =
+{
+    &factory_create_converter,
+    &factory_destroy_factory
+};
+
+static pjmedia_converter_op liswscale_converter_op =
+{
+    &libswscale_conv_convert,
+    &libswscale_conv_destroy
+};
+
+static pj_status_t factory_create_converter(pjmedia_converter_factory *cf,
+					    pj_pool_t *pool,
+					    const pjmedia_conversion_param *prm,
+					    pjmedia_converter **p_cv)
+{
+    enum PixelFormat srcFormat, dstFormat;
+    const pjmedia_video_format_detail *src_detail, *dst_detail;
+    const pjmedia_video_format_info *src_fmt_info, *dst_fmt_info;
+    struct SwsContext *sws_ctx;
+    struct ffmpeg_converter *fcv;
+    pj_status_t status;
+
+    PJ_UNUSED_ARG(cf);
+
+    /* Only supports video */
+    if (prm->src.type != PJMEDIA_TYPE_VIDEO ||
+	prm->dst.type != prm->src.type ||
+	prm->src.detail_type != PJMEDIA_FORMAT_DETAIL_VIDEO ||
+	prm->dst.detail_type != prm->src.detail_type)
+    {
+	return PJ_ENOTSUP;
+    }
+
+    /* lookup source format info */
+    src_fmt_info = pjmedia_get_video_format_info(
+		      pjmedia_video_format_mgr_instance(),
+		      prm->src.id);
+    if (!src_fmt_info)
+	return PJ_ENOTSUP;
+
+    /* lookup destination format info */
+    dst_fmt_info = pjmedia_get_video_format_info(
+		      pjmedia_video_format_mgr_instance(),
+		      prm->dst.id);
+    if (!dst_fmt_info)
+	return PJ_ENOTSUP;
+
+    src_detail = pjmedia_format_get_video_format_detail(&prm->src, PJ_TRUE);
+    dst_detail = pjmedia_format_get_video_format_detail(&prm->dst, PJ_TRUE);
+
+    status = pjmedia_format_id_to_PixelFormat(prm->src.id, &srcFormat);
+    if (status != PJ_SUCCESS)
+	return PJ_ENOTSUP;
+
+    status = pjmedia_format_id_to_PixelFormat(prm->dst.id, &dstFormat);
+    if (status != PJ_SUCCESS)
+	return PJ_ENOTSUP;
+
+    sws_ctx = sws_getContext(src_detail->size.w, src_detail->size.h, srcFormat,
+		             dst_detail->size.w, dst_detail->size.h, dstFormat,
+			     SWS_BICUBIC,
+			     NULL, NULL, NULL);
+    if (sws_ctx == NULL)
+	return PJ_ENOTSUP;
+
+    fcv = PJ_POOL_ZALLOC_T(pool, struct ffmpeg_converter);
+    fcv->base.op = &liswscale_converter_op;
+    fcv->sws_ctx = sws_ctx;
+    fcv->src.apply_param.size = src_detail->size;
+    fcv->src.fmt_info = src_fmt_info;
+    fcv->dst.apply_param.size = dst_detail->size;
+    fcv->dst.fmt_info = dst_fmt_info;
+
+    *p_cv = &fcv->base;
+
+    return PJ_SUCCESS;
+}
+
+static void factory_destroy_factory(pjmedia_converter_factory *cf)
+{
+    PJ_UNUSED_ARG(cf);
+}
+
+static pj_status_t libswscale_conv_convert(pjmedia_converter *converter,
+					   pjmedia_frame *src_frame,
+					   pjmedia_frame *dst_frame)
+{
+    struct ffmpeg_converter *fcv = (struct ffmpeg_converter*)converter;
+    struct fmt_info *src = &fcv->src,
+	            *dst = &fcv->dst;
+    int h;
+
+    src->apply_param.buffer = src_frame->buf;
+    (*src->fmt_info->apply_fmt)(src->fmt_info, &src->apply_param);
+
+    dst->apply_param.buffer = dst_frame->buf;
+    (*dst->fmt_info->apply_fmt)(dst->fmt_info, &dst->apply_param);
+
+    h = sws_scale(fcv->sws_ctx,
+	          src->apply_param.planes, src->apply_param.strides,
+		  0, src->apply_param.size.h,
+		  dst->apply_param.planes, dst->apply_param.strides);
+
+    return h==(int)dst->apply_param.size.h ? PJ_SUCCESS : PJ_EUNKNOWN;
+}
+
+static void libswscale_conv_destroy(pjmedia_converter *converter)
+{
+    struct ffmpeg_converter *fcv = (struct ffmpeg_converter*)converter;
+    if (fcv->sws_ctx) {
+	struct SwsContext *tmp = fcv->sws_ctx;
+	fcv->sws_ctx = NULL;
+	sws_freeContext(tmp);
+    }
+}
+
+static pjmedia_converter_factory libswscale_factory =
+{
+    NULL, NULL,					/* list */
+    "libswscale",				/* name */
+    PJMEDIA_CONVERTER_PRIORITY_NORMAL+1,	/* priority */
+    NULL					/* op will be init-ed later  */
+};
+
+PJ_DEF(pj_status_t)
+pjmedia_libswscale_converter_init(pjmedia_converter_mgr *mgr,
+				  pj_pool_t *pool)
+{
+    libswscale_factory.op = &libswscale_factory_op;
+    PJ_UNUSED_ARG(pool);
+    return pjmedia_converter_mgr_register_factory(mgr, &libswscale_factory);
+}
+
+
+PJ_DEF(pj_status_t)
+pjmedia_libswscale_converter_shutdown(pjmedia_converter_mgr *mgr,
+				      pj_pool_t *pool)
+{
+    PJ_UNUSED_ARG(pool);
+    return pjmedia_converter_mgr_unregister_factory(mgr, &libswscale_factory,
+						    PJ_TRUE);
+}
+
+#ifdef _MSC_VER
+#   pragma comment( lib, "avutil.lib")
+#   pragma comment( lib, "swscale.lib")
+#endif
+
+#endif /* #if PJMEDIA_HAS_LIBSWSCALE && PJMEDIA_HAS_LIBAVUTIL */
Index: pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/delaybuf.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/delaybuf.c	(revision 3391)
+++ pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/delaybuf.c	(revision 3392)
@@ -22,4 +22,5 @@
 #include <pjmedia/circbuf.h>
 #include <pjmedia/errno.h>
+#include <pjmedia/frame.h>
 #include <pjmedia/wsola.h>
 #include <pj/assert.h>
Index: pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/dummy.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/dummy.c	(revision 3392)
+++ pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/dummy.c	(revision 3392)
@@ -0,0 +1,24 @@
+/* $Id$ */
+/*
+ * Copyright (C) 2008-2010 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2003-2008 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+#include <pjmedia/frame.h>
+#include <pjmedia/port.h>
+#include <pjmedia/types.h>
+
Index: pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/echo_common.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/echo_common.c	(revision 3391)
+++ pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/echo_common.c	(revision 3392)
@@ -21,4 +21,5 @@
 #include <pjmedia/echo.h>
 #include <pjmedia/delaybuf.h>
+#include <pjmedia/frame.h>
 #include <pjmedia/errno.h>
 #include <pj/assert.h>
Index: pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/echo_port.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/echo_port.c	(revision 3391)
+++ pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/echo_port.c	(revision 3392)
@@ -39,5 +39,5 @@
 
 static pj_status_t ec_put_frame(pjmedia_port *this_port, 
-				const pjmedia_frame *frame);
+				pjmedia_frame *frame);
 static pj_status_t ec_get_frame(pjmedia_port *this_port, 
 				pjmedia_frame *frame);
@@ -53,9 +53,13 @@
 {
     const pj_str_t AEC = { "EC", 2 };
+    pjmedia_audio_format_detail *afd;
     struct ec *ec;
     pj_status_t status;
 
     PJ_ASSERT_RETURN(pool && dn_port && p_port, PJ_EINVAL);
-    PJ_ASSERT_RETURN(dn_port->info.bits_per_sample==16 && tail_ms, 
+
+    afd = pjmedia_format_get_audio_format_detail(&dn_port->info.fmt, PJ_TRUE);
+
+    PJ_ASSERT_RETURN(afd->bits_per_sample==16 && tail_ms,
 		     PJ_EINVAL);
 
@@ -64,12 +68,12 @@
     
     pjmedia_port_info_init(&ec->base.info, &AEC, SIGNATURE,
-			   dn_port->info.clock_rate, 
-			   dn_port->info.channel_count, 
-			   dn_port->info.bits_per_sample,
-			   dn_port->info.samples_per_frame);
+			   afd->clock_rate,
+			   afd->channel_count,
+			   afd->bits_per_sample,
+			   PJMEDIA_AFD_SPF(afd));
 
-    status = pjmedia_echo_create2(pool, dn_port->info.clock_rate, 
-				  dn_port->info.channel_count,
-				  dn_port->info.samples_per_frame,
+    status = pjmedia_echo_create2(pool, afd->clock_rate,
+				  afd->channel_count,
+				  PJMEDIA_AFD_SPF(afd),
 				  tail_ms, latency_ms, options, &ec->ec);
     if (status != PJ_SUCCESS)
@@ -90,5 +94,5 @@
 
 static pj_status_t ec_put_frame( pjmedia_port *this_port, 
-				 const pjmedia_frame *frame)
+				 pjmedia_frame *frame)
 {
     struct ec *ec = (struct ec*)this_port;
@@ -100,5 +104,5 @@
     }
 
-    PJ_ASSERT_RETURN(frame->size == this_port->info.samples_per_frame * 2,
+    PJ_ASSERT_RETURN(frame->size == PJMEDIA_PIA_AVG_FSZ(&this_port->info),
 		     PJ_EINVAL);
 
@@ -120,5 +124,5 @@
     if (status!=PJ_SUCCESS || frame->type!=PJMEDIA_FRAME_TYPE_AUDIO) {
 	pjmedia_zero_samples((pj_int16_t*)frame->buf, 
-			     this_port->info.samples_per_frame);
+			      PJMEDIA_PIA_SPF(&this_port->info));
     }
 
Index: pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/echo_speex.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/echo_speex.c	(revision 3391)
+++ pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/echo_speex.c	(revision 3392)
@@ -21,4 +21,5 @@
 #include <pjmedia/echo.h>
 #include <pjmedia/errno.h>
+#include <pjmedia/frame.h>
 #include <pj/assert.h>
 #include <pj/log.h>
Index: pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/echo_suppress.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/echo_suppress.c	(revision 3391)
+++ pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/echo_suppress.c	(revision 3392)
@@ -21,4 +21,5 @@
 #include <pjmedia/alaw_ulaw.h>
 #include <pjmedia/errno.h>
+#include <pjmedia/frame.h>
 #include <pjmedia/silencedet.h>
 #include <pj/array.h>
Index: pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/errno.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/errno.c	(revision 3391)
+++ pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia/errno.c	(revision 3392)
@@ -115,4 +115,5 @@
     PJ_BUILD_ERR( PJMEDIA_RTP_EINDTMF,	    "Invalid DTMF digit" ),
     PJ_BUILD_ERR( PJMEDIA_RTP_EREMNORFC2833,"Remote does not support RFC 2833" ),
+    PJ_BUILD_ERR( PJMEDIA_EBADFMT,	    "Bad format"),
 
     /* RTP session errors. */
@@ -143,4 +144,5 @@
     PJ_BUILD_ERR( PJMEDIA_EWAVETOOSHORT,    "WAVE file too short" ),
     PJ_BUILD_ERR( PJMEDIA_EFRMFILETOOBIG,   "Sound frame too large for file buffer"),
+    PJ_BUILD_ERR( PJMEDIA_EAVIUNSUPP,	    "Unsupported AVI file"),
 
     /* Sound device errors: */
@@ -267,2 +269,19 @@
 }
 
+/*
+ * pjmedia_videodev_strerror()
+ */
+PJ_DEF(pj_str_t) pjmedia_videodev_strerror(pj_status_t statcode, 
+					   char *buf, pj_size_t bufsize )
+{
+    pj_str_t errstr;
+
+    /* Error not found. */
+    errstr.ptr = buf;
+    errstr.slen = pj_ansi_snprintf(buf, bufsize, 
+				   "Unknown pjmedia-videodev error %d",
+				   statcode);
+
+    return errstr;
+}
+
